stages:
  - quality
  - preparing
  - build
  - test
  - deploy_staging
  - deploy_production

.prepare_ssh:
  variables:
    GIT_STRATEGY: none
  image: node:14
  before_script:
    - 'command -v ssh-agent >/dev/null || ( apt-get update -y && apt-get install openssh-client -y )'
    - eval $(ssh-agent -s)
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - ssh-keyscan -t rsa $SSH_SERVER_IP >> ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts

quality:
  stage: quality
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  tags:
    - quality
  variables:
    SONAR_TOKEN: $SONAR_TOKEN
    SONAR_HOST_URL: $SONAR_HOST_URL
  script: 
    - sonar-scanner -Dsonar.qualitygate.wait=true
  except:
    - staging
    - production

preparing:
  stage: preparing
  image: trinhnv/php-laravel:7.4
  services:
    - mysql:5.7
  variables:
    MYSQL_DATABASE: bbs
    MYSQL_ROOT_PASSWORD: bbs_pass
  cache:
    paths:
        - vendor/
        - node_modules/
  only:
    - test
  script:
    # Update packages
    - echo "Install dependency packages"
    - COMPOSER_MEMORY_LIMIT=-1 composer install --prefer-dist --no-ansi --no-interaction --no-progress --no-scripts
    - cp .env.dev .env
    - php artisan key:generate

# Build code on develop branch
build:
  stage: build
  dependencies:
    - preparing
  only:
    - test
  script:
    # Copy over testing configuration.
    - php artisan migrate
    - php artisan db:seed

# Build code on staging branch
deploy_staging:
  stage: deploy_staging
  only:
    - staging
  tags:
    - deploy
  extends: .prepare_ssh
  script:
    - >
      ssh $SSH_USER@$SSH_SERVER_IP
      "cd $BBS_STG_DIRECTORY;
      sh .deploy.sh staging;
      exit";

# Build code on master branch
deploy_production:
  stage: deploy_production
  only:
    - production
  tags:
    - deploy
  when: manual
  extends: .prepare_ssh
  script:
    - >
      ssh $SSH_USER@$SSH_SERVER_IP
      "cd $BBS_DIRECTORY;
      sh .deploy.sh production;
      exit;"

# Test on master branch
test:
  stage: test
  only:
    - test
  script:
    - echo "test done"
